%global apiver  20131106
%global zendver 20131226
%global pdover  20080721

%global phpvar  /var/lib/php56
%define phplib %{_libdir}/php56
%define extdir %{phplib}/extensions
%define peardir %{_datadir}/php/pear

%define allow_exec_dir 1
%define _unpackaged_files_terminate_build 0

# don't build debug package
#define debug_package %{nil}
# don't binary strip
#define __spec_install_post %{nil}

%define build_fpm 1
%define php53_compatible 1

%{!?_with_no_goto:%define _vm_goto 1}
%{?_with_no_goto:%define _vm_goto 0}

Summary: The PHP HTML-embedded scripting language for use with Apache2.
Summary(ko): Apache2 PHP 엔진
Name: php56
Version: 5.6.34
Release: 1%{?dist}
Epoch: 100
Group: Development/Languages
License: PHP
Source0: http://kr1.php.net/distributions/php-%{version}.tar.bz2
Source2: info.php
Source3: macros.php
Source4: php-dependency.txt

Source100: pecl-extension.tar.bz2
Source101: httpd.conf
Source102: annyung_func_alias_table.php

Source1000: zend_vm_execute.h-goto-%{version}

# patch start
# oops patch to 1 - 99
Patch1: php-ini.patch
Patch2: php-version.patch
Patch3: php-libtool2.patch
Patch4: php-5.4.16-fpm-logpath.patch

# extension patch
Patch20: php-mysql.patch
# don' use
Patch21: php-mysql-charset.patch
Patch22: php-gd-charspace.patch
Patch23: php-libgd-freetype.patch
Patch24: php-annyung-exec-dir.patch
Patch26: php-dba.patch
# don' use
Patch27: php-snmp-shutdown.patch
Patch29: php-phpize64.patch
Patch30: php-includedir.patch
Patch31: php-tmpdir.patch
Patch32: php-annyung-alias.patch
Patch33: php-annyung-zend-listed-table.patch
# Patch 34 and Patch 35 are dependent on patch 33
Patch34: php-annyung-include-file-check.patch
# Patch 35 is dependent on Patch 34
Patch35: php-annyung-image-attack.patch
# block '\0' to path after 5.3.4RC1. still need?
# don' use
Patch36: php-annyung-urldecode-hex-null.patch
Patch37: php-annyung-realpath-cache-force.patch

# php 5.3 compatible
Patch51: php-annyung-5.3-compatible-option.patch
Patch52: php-annyung-5.3-compatible-functions.patch
Patch53: php-annyung-5.3-creative-default-object-nowarning.patch
Patch54: php-annyung-5.3-allow-call_time_pass_reference.patch
Patch55: php-annyung-5.3-magic_quotes.patch

# patch for rhel5
Patch100: php-4.3.1-odbc.patch
Patch101: php-fc-dlopen.patch
Patch103: php-5.3.18-gnusrc.patch
Patch104: php-5.3.18-systzdata-v7.patch
Patch105: php-5.3.18-embed.patch

# patch third party extension
# don' use
Patch201: php-libevent-1.4.patch
Patch202: php-sqlite-php54.patch
Patch203: php-sqlite-config.patch
Patch204: php-event-sockets-config.patch

# private patch
# http://wiki.ohgaki.net/index.php?PHP%2Fpatch
Patch3000: php-allow_url_fopen-INI_ALL.patch

# offcial patch
#Patch5001: php-5.6.29-official-b73549.patch

Patch9000: php-5.3.1-unofficial-bug-51056-fread.patch
Patch9001: php-5.6-compat.patch

# security
#Patch6000: php-5.5.10-CVE-2013-7345.patch


# patch end
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: webserver, php56-common, libicu, bzip2-libs
Requires: openssl, zlib
BuildRequires: readline-devel, ncurses-devel, zlib-devel, file >= 4, re2c
BuildRequires: libpng-devel, libjpeg-devel, db4-devel, gdbm-devel
#BuildRequires: openssl-devel, zlib-devel, libxml2-devel, mysql-devel
BuildRequires: openssl-devel, zlib-devel, libxml2-devel bison
BuildRequires: curl-devel, freetds-devel, freetype-devel
BuildRequires: libmcrypt-devel, mhash-devel, libicu-devel
BuildRequires: libevent-devel >= 1.4, net-snmp-devel sqlite-devel
BuildRequires: httpd-devel, openldap-devel bzip2-devel MTA
BuildRequires: imap-devel gmp-devel unixODBC-devel
Provides: php56api
Obsoletes: php56-intl php56-pdo php56-xmlrpc php56-mbstring

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

Building option:
	--with no_goto : if don't add vm kind option with goto..

%package cli
Group: Development/Languages
Summary: php command line interface
Summary(ko): php56 cli 인터페이스
Requires: php56-common, readline, ncurses, zlib, openssl, libicu
Provides: php56api
Obsoletes: php56-intl php56-pdo php56-xmlrpc php56-mbstring

%description cli
php 5.6 binary file to use in shell

%package fpm
Group: Development/Languages
Summary: php56 fpm engine
Requires: php56-fpm-conf, zlib, openssl, libicu, ncurses, libicu
Provides: php56api
Obsoletes: php56-intl php56-pdo php56-xmlrpc php56-mbstring

%description fpm
php 5.6 fastcgi(fpm) server api

%package devel
Group: Development/Libraries
Summary: php 5.6 development file for making extensions
Summary: php 5.6 확장 개발을 위한 파일들

%description devel
php 5.6 build file for making extensions

%package extension
Group: Development/Languages
Summary: php 5.6 shared extension
Requires: php56api
Requires: libjpeg, db4, gdbm, file, curl, openldap
#Requires: sqlite, mysql-shared, freetype, freetds, libpng, libmcrypt, mhash
Requires: sqlite, freetype, freetds, libpng, libmcrypt, mhash
Requires: libicu, libevent >= 1.4, net-snmp-libs

# compatible php base package
Provides: php56-bcmath php56-calendar php56-curl php56-event php56-exif
Provides: php56-fileinfo php56-ftp php56-gd php56-gettext php56-gmp
Provides: php56-imap php56-json php56-ldap php56-libevent php56-mcrypt
Provides: php56-memcache php56-mysql php56-mysqli php56-opcache php56-pdo_mysql
Provides: php56-pdo_sqlite php56-snmp php56-soap php56-sqlite php56-sqlite3
Provides: php56-wddx php56-xmlreader php56-xmlwriter php56-zip php56-xml
Provides: php56-mysqlnd php56-pecl-memcache


%description extension
This package include php 5.6 shared extension

%package dba
Group: Development/Languages
Summary: PHP 5.6 dba extension
Summary(ko): PHP 5.6 dba 확장
Requires: php56api db4 gdbm

%description dba
PHP 5.6 Database (dbm-style) Abstraction Layer extension


%package mssql
Group: Development/Languages
Summary: PHP 5.6 mssql extension
Summary(ko): PHP 5.6 dba 확장
Requires: php56api freetds

%description mssql
PHP 5.6 Microsoft SQL Server and Sybase Functions


%package odbc
Group: Development/Languages
Summary: PHP 5.6 odbc extension
Summary(ko): PHP 5.6 odbc 확장
Requires: php56api unixODBC

%description odbc
PHP 5.6 ODBC and PDO ODBC interface APIs


%package pgsql
Group: Development/Languages
Summary: PHP 5.6 pgsql and pdo_pgsql extension
Summary(ko): PHP 5.6 pgsql, pdo_pgsql 확장
Requires: php56api postgresql-libs

%description pgsql
PHP 5.6 pgsql and PDO PgSQL interface APIs


%prep
%setup -q -n php-%{version} -a 100

pushd $RPM_BUILD_DIR/php-%{version} &> /dev/null
tar xvfpj %{SOURCE100}
popd &> /dev/null

# official patch
#patch5001 -p1

%patch9000 -p1

# sec
#patch6000 -p1

%patch1 -p1
# extra version to AnNyung
#patch2 -p1
%patch3 -p1
%if %{build_fpm}
# already 5.6-compat patch
#patch4 -p1
%endif

%patch20 -p1
#patch21 -p1
%patch22 -p1
%patch23 -p1
%if %{allow_exec_dir}
%patch24 -p1
%endif
%patch26 -p1
#patch27 -p1
# areldy 5.6-compat
#patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
#patch36 -p1
%patch37 -p1

%if %{php53_compatible}
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p1
%patch55 -p1
%endif

# fedora patch
%patch100 -p1
%patch101 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

# private update
%patch3000 -p1

#patch201 -p0
%patch202 -p0
%patch203 -p1
%patch204 -p1

%patch9001 -p1


%if %{_vm_goto}
# memory allocated를 실패하면, swapfile을 생성해서 등록해서 진행할 것!
pushd Zend
	# php 5.3 support --with-zend-vm=GOTO. is applicated really?
	if [ -f "/usr/bin/php" ]; then
		%{__rm} -f zend_vm_execute.h
		php zend_vm_gen.php --with-vm-kind=GOTO

		# 5.6 bug? constant_fetch_end label 중복 에러로, 파일 생성해서
		#중복 수정한 파일 이용
		%{__rm} -f zend_vm_execute.h
		%{__install} -m644 %{SOURCE1000} ./zend_vm_execute.h
	fi
popd
%endif

%build

BuildPHP() {
	[ ! -d "%{phpvar}/tmp" ] && mkdir -p %{phpvar}/tmp && chmod 1777 %{phpvar}/tmp
	#OOPS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing -Wno-pointer-sign"
	RPMS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing"
	export CFLAGS="-fPIC ${RPMS_FLAGS}"
	export EXTENSION_DIR=%{extdir}
	export PEAR_INSTALLDIR=%{peardir}

	case "$1" in
		cli) scandir="cli"; shift ;;
		apache) scandir="apache"; shift ;;
		fpm) scandir="fpm"; shift ;;
	esac

#		--without-pic \
	%{configure} \
		--with-zend-vm=GOTO \
		--with-libdir=%{_lib} \
		--sysconfdir=%{_sysconfdir}/php56.d \
		--with-config-file-path=%{_sysconfdir}/php56.d \
		--with-config-file-scan-dir=%{_sysconfdir}/php56.d/$scandir \
		--disable-debug \
		--disable-opcache \
		--disable-xmlreader \
		--disable-xmlwriter \
		--disable-json \
		--without-pear \
		--without-sqlite \
		--without-sqlite3 \
		--with-regex=php \
		--with-bz2 \
		--with-zlib \
		--with-zlib-dir=%{_prefix} \
		--enable-mod-charset \
		--enable-zend-signals \
		--enable-sigchild \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-sysvmsg \
		--enable-mysqlnd \
		--enable-intl \
		--enable-soap=shared \
		--enable-pdo \
		--without-pdo-sqlite \
		--without-pdo-mysql \
		--enable-sockets \
		--enable-mbstring=all \
		--enable-mbregex \
		--enable-mbregex-backtrack \
		--with-libmbfl \
		--with-iconv \
		--with-openssl \
		--with-xmlrpc \
		--with-system-tzdata \
		--with-mysql-sock=/var/run/mysqld/mysql.sock \
		$*

	%{__make} %{?_smp_mflags}
}

%{__rm} -f configure

# aclocal workaround - to be improved
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >>aclocal.m4

# pull latest ltmain.sh, AC_PROG_LIBTOOL
# Force use of system libtool:
libtoolize --force --copy
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >build/libtool.m4
# force aclocal run during buildconf
touch acinclude.m4

./buildconf --force

# binary compile
BuildPHP cli \
		--with-exec-dir="" \
		--enable-pcntl \
		--with-readline \
		--with-ncurses \
		--disable-cgi \
		--enable-static

mv sapi/cli/php sapi/cli/php-cli
mv sapi/cli/php.1 sapi/cli/php.1.cli
%{__mkdir_p} %{buildroot}%{_bindir}
mv ext/phar/phar.phar ext/phar/phar.phar.cli

# build fastcgi module
%{__make} clean

%if %{build_fpm}
BuildPHP fpm \
		--with-exec-dir=%{phpvar}/bin \
		--enable-fpm \
		--disable-cli \
		--enable-pcntl \
		--enable-bcmath=shared \
		--enable-calendar=shared \
		--with-curl=shared,%{_prefix} \
		--enable-dba=shared \
			--with-gdbm \
			--with-dbm \
			--with-db4 \
		--enable-exif=shared \
		--with-event-core=shared \
			--with-event-openssl \
			--with-event-extra \
			--enable-event-sockets \
		--enable-fileinfo=shared \
		--enable-ftp=shared \
		--with-gd=shared \
			--enable-gd-native-ttf \
			--with-jpeg-dir=%{_prefix} \
			--with-png-dir=%{_prefix} \
			--with-freetype-dir=%{_prefix} \
		--with-gettext=shared \
		--with-gmp=shared \
		--with-imap=shared --with-imap-ssl \
		--enable-json=shared \
		--with-ldap=shared --with-ldap-sasl \
		--with-libevent=shared \
		--with-mcrypt=shared \
		--enable-memcache=shared \
		--with-mssql=shared \
		--with-mysql=shared,mysqlnd \
		--with-mysqli=shared,mysqlnd \
		--enable-opcache \
		--with-pdo-mysql=shared,mysqlnd \
		--with-pdo-pgsql=shared,mysqlnd \
		--with-pdo-sqlite=shared,%{_prefix} \
		--with-pgsql=shared \
		--with-snmp=shared,%{_prefix} \
		--with-sqlite=shared --enable-sqlite-utf8 \
		--with-sqlite3=shared \
		--with-unixODBC=shared,%{_prefix} \
		--enable-wddx=shared \
		--enable-xmlreader=shared, --enable-xmlwriter=shared \
		--enable-zip=shared

#mv sapi/fpm/php-fpm sapi/fpm/php-fpm-back
#mv sapi/fpm/php-fpm.8 sapi/fpm/php-fpm.8.fpm

%endif

cd modules
/bin/ls *.so | sed 's/^/;extension = /' > ../extensions.ini
cd -

%install
[ "%{buildroot}" != "/" -a -d "${buildroot}" ] && rm -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf
install -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

%{__make} install INSTALL_ROOT=%{buildroot} INSTALL_ID="echo "



rm -rf %{buildroot}%{extdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{extdir}
mkdir -p %{buildroot}/home/httpd/html
mkdir -p %{buildroot}%{_mandir}/{man1,man8}
mkdir -p %{buildroot}%{_sysconfdir}/php56.d/{cli,apache}

install -m 755 ext/phar/phar.phar.cli %{buildroot}%{_bindir}/phar56.phar
cd %{buildroot}%{_bindir}
ln -sf phar56.phar phar56
cd -

install -m 755 sapi/cli/php-cli %{buildroot}%{_bindir}/php56
install -m 644 sapi/cli/php.1.cli %{buildroot}%{_mandir}/man1/php56.1
#(cd %{buildroot}%{_bindir}; ln -sf php php5)
install -m 755 -s modules/*.so %{buildroot}%{extdir}
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php56.d/php.ini
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php56.d/php-cli.ini
install -m 644 %{SOURCE2} %{buildroot}/home/httpd/html/php_info.php

install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php56.d/apache/shared.ini
install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php56.d/cli/shared.ini


%if %{build_fpm}
%{__mkdir_p} %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_mandir}/man8
install -m 755 sapi/fpm/php-fpm %{buildroot}%{_sbindir}/php56-fpm
install -m 644 sapi/fpm/php-fpm.8  %{buildroot}%{_mandir}/man8/php56-fpm.8
%endif

%{__mkdir_p} %{buildroot}%{peardir}
install -m 644 %{SOURCE102} %{buildroot}/%{peardir}/alias_table.php

mv LICENSE LICENSE.php56

# session and update tmp dir
mkdir -p %{buildroot}%{phpvar}/{sessions,tmp,bin}

# dependency problem
pushd %{buildroot}%{phplib}/build
	chmod 644 *
	chmod 755 shtool
popd

# Generate files lists and stub .ini files for each subpackage
for mod in $(ls %{buildroot}%{extdir}/*.so)
do
	modname=$(basename $mod | sed 's/\.so//g')

	[ "${modname}" = "dba" -o "${modname}" = "mssql" ] && continue
	[ "${modname}" = "odbc" ] && continue
	[ "${modname}" = "pgsql" -o "${modname}" = "pdo_pgsql" ] && continue

	cat >> files.ext <<EOF
%attr(755,root,root) %{extdir}/${modname}.so
EOF
done

# Package pdo_sqlite with pdo; isolating the sqlite dependency
# isn't useful at this time since rpm itself requires sqlite.
#cat files.pdo_sqlite >> files.pdo

# Install the macros file:
install -d %{buildroot}%{_sysconfdir}/rpm
sed -e "s/@PHP_APIVER@/%{apiver}/;s/@PHP_ZENDVER@/%{zendver}/;s/@PHP_PDOVER@/%{pdover}/" \
    < $RPM_SOURCE_DIR/macros.php > macros.php56.php
install -m 644 -c macros.php56.php \
           %{buildroot}%{_sysconfdir}/rpm/macros.php56.php

cd %{buildroot}%{_sysconfdir}/php56.d/
for dname in apache cli
do
	cat >> ${dname}/dba.ini <<EOF
extension = dba.so
EOF

	cat >> ${dname}/mssql.ini <<EOF
extension = mssql.so
EOF

	cat >> ${dname}/odbc.ini <<EOF
extension = odbc.so
EOF

	cat >> ${dname}/pgsql.ini <<EOF
extension = pgsql.so
extension = pdo_pgsql.so
EOF
done
cd -


# Remove unpackaged files
rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf \
       %{buildroot}%{_bindir}/{phptar} \
       %{buildroot}%{_datadir}/pear

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
rm -f files.* macros.php56.php

%files cli
%defattr(-,root,root)
%attr(755,root,root) %{_bindir}/php56
%attr(755,root,root) %{_bindir}/phar56.phar
%{_bindir}/phar56
%{_mandir}/man1/php56.1*

%if %{build_fpm}
%files fpm
%attr(755,root,root) %{_sbindir}/php56-fpm
%{_mandir}/man8/php56-fpm.8*
%endif

%files devel
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rpm/macros.php56.php
%{_bindir}/php56-config
%{_bindir}/phpize56
%{_includedir}/php56
%{_libdir}/php56/build

%files extension -f files.ext

%files dba
%attr(755,root,root) %{extdir}/dba.so
%attr(644,root,root) %{_sysconfdir}/php56.d/apache/dba.ini
%attr(644,root,root) %{_sysconfdir}/php56.d/cli/dba.ini

%files mssql
%attr(755,root,root) %{extdir}/mssql.so
%attr(644,root,root) %{_sysconfdir}/php56.d/apache/mssql.ini
%attr(644,root,root) %{_sysconfdir}/php56.d/cli/mssql.ini

%files odbc
%attr(755,root,root) %{extdir}/odbc.so
%attr(644,root,root) %{_sysconfdir}/php56.d/apache/odbc.ini
%attr(644,root,root) %{_sysconfdir}/php56.d/cli/odbc.ini

%files pgsql
%attr(755,root,root) %{extdir}/pgsql.so
%attr(755,root,root) %{extdir}/pdo_pgsql.so
%attr(644,root,root) %{_sysconfdir}/php56.d/apache/pgsql.ini
%attr(644,root,root) %{_sysconfdir}/php56.d/cli/pgsql.ini

%changelog
* Sat Mar 17 2018 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.34-1%{?dist}
- update 5.6.34
  . http://kr.php.net/ChangeLog-5.php#5.6.34
- security issues
  . CVE-2018-7584 Standard: stack-buffer-overflow while parsing HTTP response (#75981)

* Sun Feb  4 2018 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.33-1%{?dist}
- update 5.6.33
  . http://kr.php.net/ChangeLog-5.php#5.6.33
- if upload_image_check is on, only add sec and secstr member of $_FILES

* Mon Nov  6 2017 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.32-1%{?dist}
- update 5.6.32
  . http://kr.php.net/ChangeLog-5.php#5.6.32
- security issues
  . CVE-2016-1283 PCRE preg_match double free

* Sat Sep  2 2017 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.31-1%{?dist}
- update 5.6.31
- fixed exec_dir bug
  . fixed #15 But when using "2>&1" in exec command
  . fixed #16 error "NULL byte detected."

- security issues
  . CVE-2017-9224 mbstring
  . CVE-2017-9226 mbstring
  . CVE-2017-9227 mbstring
  . CVE-2017-9228 mbstring
  . CVE-2017-9229 mbstring

* Fri May 26 2017 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.30-1%{?dist}
- update 5.6.30

* Sat Jan  7 2017 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.29-2%{?dist}
- fixed 5.6.29 official bug
  . fixed #73737 Exif: FPE when parsing a tag format
  . fixed #73530 Sqlite3: Unsetting result set may reset other result set
  . fixed #70213 Standard: Unserialize context shared on double class lookup
  . fixed #73825 (Heap out of bounds read on unserialize in finish_nested_data()
  . fixed #73764 Phar: Crash while loading hostile phar archive
  . fixed #73768 Phar: Memory corruption when loading hostile phar
  . fixed #73773 Phar: Seg fault when loading hostile phar

- security issues
  . exec_dir: #8 backquote and $() syntax weakness after semi colon
    https://github.com/OOPS-ORG-PHP/mod_execdir/issues/8

* Mon Dec 19 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.29-1%{?dist}
- fixed 5.6.29 official bug
  . fixed #73549 GD: Use after free when stream is passed to imagepng
  . fixed #68447 Intl: grapheme_extract take an extra trailing character
- security issues
  . fixed #73505 string length overflow in mbfl_memory_device_output function
  . fixed #73402 Opcache segfault when using class constant to call a method
  . fixed #72776 Invalid parameter in memcpy function trough openssl_pbkdf2
  . fixed #73452 Soap segfault (Regression for #69152)
  . fixed #73213 Integer overflow in imageline() with antialiasing
  . fixed #73279 Integer overflow in gdImageScaleBilinearPalette()
  . fixed #73280 Stack Buffer Overflow in GD dynamicGetbuf
  . fixed #72482 Illegal write/read access caused by gdImageAALine overflow
  . fixed #72696 imagefilltoborder stackoverflow on truecolor images
  . fixed #73418 Integer Overflow in "_php_imap_mail" leads Heap Overflow
  . fixed #73331 NULL Pointer Dereference in WDDX Packet Deserialization with PDORow

* Sun Oct  2 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.26-1%{?dist}
- fixed 5.6.27 official bug
  . fixed #73025 Core: Heap Buffer Overflow in virtual_popen of zend_virtual_cwd.c
  . fixed #73058 Core: crypt broken when salt is 'too' long
  . fixed #72703 Core: Out of bounds global memory read in BF_crypt triggered by password_verify
  . fixed #72972 Filter: Bad filter for the flags FILTER_FLAG_NO_RES_RANGE and FILTER_FLAG_NO_PRIV_RANGE
  . fixed #67167 Filter: Wrong return value from FILTER_VALIDATE_BOOLEAN, FILTER_NULL_ON_FAILURE
  . fixed #73054 Filter: default option ignored when object passed to int filter
  . fixed #67325 GD: imagetruecolortopalette: white is duplicated in palette
  . fixed #50194 GD: imagettftext broken on transparent background w/o alphablending
  . fixed #73003 GD: Integer Overflow in gdImageWebpCtx of gd_webp.c (CVE-2016-7568)
  . fixed #53504 GD: imagettfbbox gives incorrect values for bounding box
  . fixed #73157 GD: imagegd2() ignores 3rd param if 4 are given
  . fixed #73155 GD: imagegd2() writes wrong chunk sizes on boundaries
  . fixed #73159 GD: imagegd2(): unrecognized formats may result in corrupted files
  . fixed #73161 GD: imagecreatefromgd2() may leak memory
  . fixed #72994 Mbstring: mbc_to_code() out of bounds read
  . fixed #66964 Mbstring: mb_convert_variables() cannot detect recursion
  . fixed #72992 Mbstring: mbstring.internal_encoding doesn't inherit default_charset
  . fixed #72590 Opcache: Opcache restart with kill_all_lockers does not work
  . fixed #73072 Openssl: Invalid path SNI_server_certs causes segfault
  . fixed #68015 Session: Session does not report invalid uid for files save handler
  . fixed #73100 Session: session_destroy null dereference in ps_files_path_create
  . fixed #73069 Stream: readfile() mangles files larger than 2G
  . fixed #70752 Zip: Depacking with wrong password leaves 0 length files

- fixed 5.6.28 official bug
  . fixed bug #73203 Standard: passing additional_parameters causes mail to fail
  . fixed bug #73213 GD: Integer overflow in imageline() with antialiasing

- security issues
  . CVE-2016-7568 GD: Integer Overflow in gdImageWebpCtx of gd_webp.c (#73003)
  . CVE-2016-5385 Core: HTTP_PROXY is improperly trusted by some PHP libraries and applications (#72573)
  . CVE-2016-6207 GD: Integer overflow error within _gdContributionsAlloc() (#72558)
  . CVE-2015-8874 GD: Stack overflow with imagefilltoborder (#66387)
  . CVE-2016-5766 GD: Integer Overflow in _gd2GetHeader() resulting in heap overflow (#72339)
  . CVE-2016-5767 GD: Integer Overflow in gdImagePaletteToTrueColor() resulting in heap overflow (#72446)
  . CVE-2016-5768 Mbstring: _php_mb_regex_ereg_replace_exec - double free (#72402)
  . CVE-2016-5769 Mcrypt: Heap Overflow due to integer overflows (#72455)
  . CVE-2016-5770 SPL: int/size_t confusion in SplFileObject::fread (#72262)
  . CVE-2016-5771 SPL: Use After Free Vulnerability in PHP's GC algorithm and unserialize (#72433)
  . CVE-2016-5772 WDDX: Double Free Courruption in wddx_deserialize (#72340)
  . CVE-2016-5773 Zip: ZipArchive class Use After Free Vulnerability in PHP's GC algorithm and unserialize (#72434)


* Mon Aug  1 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.22-2%{?dist}
- fixed conflict obsolate and provides with php 7 package

* Tue Jun 21 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.22-1%{?dist}
- fixed zend_mm_heap corrupted problems of exec_dir patch
- security isseus
  . CVE-2016-3074 libgd: signedness vulnerability (#71912)
  . CVE-2015-8865 Buffer over-write in finfo_open with malformed magic file (#71527)
  . CVE-2016-4073 AddressSanitizer: negative-size-param (-1) in mbfl_strcut (#71906)
  . CVE-2016-4072 Invalid memory write in phar on filename with \0 in name (#71860)
  . CVE-2016-4071 php_snmp_error() Format String Vulnerability (#71704)
  . CVE-2016-4070 Integer Overflow in php_raw_url_encode (#71798)
  . CVE-2016-5096 Core: Integer underflow / arbitrary null write in fread/gzread (#72114)
  . CVE-2016-5094 Core: Integer Overflow in php_html_entities (#72135)
  . CVE-2013-7456 GD: imagescale out-of-bounds read (#72227)
  . CVE-2016-5093 Intl: get_icu_value_internal out-of-bounds read (#72241)

- fixed 5.6.22 Official bug
  . fixed #72140 OpenSSL: segfault after calling ERR_free_strings()
  . fixed #70484 Intl: selectordinal doesn't work with named parameters
  . fixed #72337 GD: invalid dimensions can lead to crash

- fixed 5.6.23 Official bug
  . fixed #72439 Stream: tream socket with remote address leads to a segmentation fault
  . fixed #72336 OpenSSL: openssl_pkey_new does not fail for invalid DSA params
  . fixed #72915 OpenSSL: openssl_random_pseudo_bytes is not fork-safe
  . fixed #50854 EXIF: exif_read_data() returns corrupted exif headers
  . fixed #72138 Core: Integer Overflow in Length of String-typed ZVAL
  . fixed #72447 bz2: Type Confusion in php_bz2_filter_create()
  . fixed #43475 GD: Thick styled lines have scrambled patterns
  . fixed #53640 GD: XBM images require width to be multiple of 8
  . fixed #64641 GD: imagefilledpolygon doesn't draw horizontal line

* Tue Feb 16 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.18-1%{?dist}
- fixed official bugs
  . fixed bug #71523 CURL: Copied handle with new option CURLOPT_HTTPHEADER crashes while curl_multi_exec
  . fixed bug #68078 Date: Datetime comparisons ignore microseconds
  . fixed bug #71525 Date: Calls to date_modify will mutate timelib_rel_time, causing date_date_set issues
  . fixed bug #71434 Fileinfo: finfo throws notice for specific python file
  . fixed bug #62172 FRPM: FPM not working with Apache httpd 2.4 balancer/fcgi setup
  . fixed bug #71584 Opcache: Possible use-after-free of ZCG(cwd) in Zend Opcache
  . fixed bug #71569 #70389 PDO MySQL: fix causes segmentation fault
  . fixed bug #70720 Standard: strip_tags improper php code parsing
  . fixed bug #71540 XSL: NULL pointer dereference in xsl_ext_function_php()
  . fixed bug #71561 Zip: NULL pointer dereference in Zip::ExtractTo

* Wed Jan 13 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.17-1%{?dist}
- 5.6.17 compat package

* Mon Jan 11 2016 JoungKyun.Kim <hostmaster@oops.org> 100:5.5.17-1%{?dist}
- udpate 5.6.17
- official bug fixed
  . fixed bug #71201 Core: round() segfault on 64-bit builds
  . fixed bug #71089 Core: No check to duplicate zend_extension
  . Core: Added support for new HTTP 451 code
  . Implemented FR #55651 FTP: Option to ignore the returned FTP PASV address
  . fixed bug #71127 Opcache: Define in auto_prepend_file is overwrite
  . fixed bug #71122 Session: Session GC may not remove obsolete session data
  . fixed bug #71204 SPL: segfault if clean spl_autoload_funcs while autoloading
  . fixed bug #70720 Standard: strip_tags improper php code parsing

* Tue Oct 13 2015 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.14-1%{?dist}
- update 5.6.14
- official bug fixed
  . #70681 Core: Segfault when binding $this of internal instance method to null
  . #70685 Core: Segfault for getClosure() internal method rebind with invalid $this
  . #70619 Date: DateTimeImmutable segfault
  . #70625 Mcrypt: mcrypt_encrypt() won't return data when no IV was specified under RC4
  . #70384 Mysqlnd: mysqli_real_query():Unknown type 245 sent by the server
  . #70572 Mysqlnd: segfault in mysqlnd_connect
  . #70601 Opcache: Segfault in gc_remove_from_buffer()
  . #70631 Opcache: Another Segfault in gc_remove_from_buffer()
  . #70632 Opcache: Third one of segfault in gc_remove_from_buffer

* Tue Sep  1 2015 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.12-1%{?dist}
- update 5.6.12
- offcial bug fixed
  . #70052 getimagesize() fails for very large and very small WBMP
  . #70157 parse_ini_string() segmentation fault with INI_SCANNER_TYPED
  . #70290 Null pointer deref (segfault) in spl_autoload via ob_start
  . #70303 Incorrect constructor reflection for ArrayObject
  . #70232 Incorrect bump-along behavior with \K and empty string match
  . #70237 Empty while and do-while segmentation fault with opcode on CLI enabled
  . #69833 mcrypt fd caching not working
  . #70266 DateInterval::__construct.interval_spec is not supposed to be optional
  . #70277 new DateTimeZone($foo) is ignoring text after null byte 
  . #66606 Sets HTTP_CONTENT_TYPE but not CONTENT_TYPE
  . #70264 CLI server directory traversal 
  . #69900 Too long timeout on pipes
  . #69487 SAPI may truncate POST data
  . #70198 Checking liveness does not work as expected
  . #67131 setcookie() conditional for empty values not met
  . #70389 PDO constructor changes unrelated variables
  . #55259 openssl extension does not get the DH parameters from DH key resource

* Tue Mar 10 2015 JoungKyun.Kim <hostmaster@oops.org> 100:5.6.6-1%{?dist}
- update 5.6.6

